
% Evolving process

function [u,spf] = Evolu_LG(u0,Img,g,mu,Ksigma,epsilon,timestep,w,numIter,lambda,alf)

u=u0;


for k1=1:numIter
    u = NeumannBoundCond(u);
    [ux,uy] = gradient(u);

    Hu = Heaviside(u,epsilon);
    [f1,f2] = Local_Avr(Img,Hu,Ksigma);
      
    Imgloc_1 = f1.*Hu + f2.*(1 - Hu);
    
    [C1,C2] = binaryfit(Img,Hu);  %Test Img and Imgloc
    

      
    spfgl = Imgloc_1 - (C1 + C2)/2;   
    spfloc = Img - (f1 + f2)/2;
    spf = (w*spfgl+(1-w)*spfloc);
   
    spf = spf/(max(abs(spf(:))));  %tyun M 10.3.20
    
    weightedLengthTerm=lambda.*(ux.^2 + uy.^2);
    weightedAreaTerm=alf.*sqrt(ux.^2 + uy.^2).*g;
    DataTerm = mu*spf.*sqrt(ux.^2 + uy.^2);    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%the proposed model    
    u=u+timestep*(DataTerm+weightedAreaTerm+weightedLengthTerm);
    
end

function g = NeumannBoundCond(f)
% Neumann boundary condition
[nrow,ncol] = size(f);
g = f;
g([1 nrow],[1 ncol]) = g([3 nrow-2],[3 ncol-2]);  
g([1 nrow],2:end-1) = g([3 nrow-2],2:end-1);          
g(2:end-1,[1 ncol]) = g(2:end-1,[3 ncol-2]);  

function H = Heaviside(phi,epsilon)
H = 0.5*(1+(2/pi)*atan(phi./epsilon));
                                                         
function [f1,f2] = Local_Avr(I,H,K)
f1 = conv2(I.*H,K,'same');
c1 = conv2(H,K,'same');
f1 = f1./c1;
f2 = conv2(I.*(1-H),K,'same');
c2 = conv2(1-H,K,'same');
f2 = f2./c2;

function f = Dirac(x, sigma)
f=(1/2/sigma)*(1+cos(pi*x/sigma));
b = (x<=sigma) & (x>=-sigma);
f = f.*b;

function K = curvature_central(nx,ny);
[nxx,junk]=gradient(nx);  
[junk,nyy]=gradient(ny);
K=nxx+nyy;

