


clc;clear all;close all;
file_name = 'CAS_F3-2_7_Gaussian.jpg';
Img = imread(file_name);  %heart Image
[pathstr,image_name,ext] = fileparts(file_name); 

Img = Img(:,:,1);
Img = double(Img);

[nrow,ncol] = size(Img);
 
initialLSF=sdf2circle(nrow,ncol, nrow/2,ncol/2,100);   % circle initialize
phi = round(((initialLSF > 0)-0.5) .* 2);

% phi = ones(nrow,ncol);       % retangular initialize
% phi(150:nrow-150,150:ncol-150) = -1; % contour


ic=nrow/2;                      
jc=ncol/2;
r=30;

u = -phi;

figure;h_img = imagesc(Img, [0, 255]);colormap(gray);hold on;axis off,axis equal
title('Initial contour');
[c,h] = contour(u,[0 0],'r','linewidth',2);
save_name = [image_name '_0.jpg'];
saveas(h_img, save_name);

pause(0.1);



% Set parameters
sigma =2.;  % Gaussian kernel for image
sigma_u = 1.;  % Gaussian kernel for binary map
             
timestep = 1.;     

iterNum = 3000; % Iteration number 
mu = 10.;  % Weight of spf function
epsilon = 1.5;  % Parameter of Heaviside function
w =.5;  % Weight of spf function (global region term and local region term)
alf =0.5; % Weight of egde          
lambda =0.;  % weight of length of contour
cri_th = 1e-4 ;
              
               
K = fspecial('gaussian',2*round(2*(sigma))+1,sigma);
K_u = fspecial('gaussian',5, sigma_u);  %1c:5;

Img_smooth=conv2(Img,K,'same');  % smooth image by Gaussiin convolution
[Ix,Iy]=gradient(Img_smooth);
f=Ix.^2+Iy.^2; % edge
g=1./(1+f);  % edge indicator function.

starttime = cputime;
u_old = u ;

for n = 1:iterNum
    [u1,spf] = Evolu_LG(u,Img,g,mu,K,epsilon,timestep,w,1,lambda,alf);
    u = u1;
    u = (u >= 0) - ( u< 0); % the selective step.           
    u = conv2(u, K_u, 'same');
   
    % Draw the contour
    if mod(n,10)==0
        fprintf('Current iteration:%d.\n', n);
        pause(0.1);
        h_img = imagesc(Img, [0, 255]);
        colormap(gray);hold on;axis off,axis equal
        [c,h] = contour(u,[0 0],'r','linewidth',2); 
        iterNum=[num2str(n), ' iterations'];
        title(iterNum);
        hold off;
        
        if mod(n,50)==0
            save_name = sprintf([image_name '_%d.jpg'], n);
            saveas(h_img, save_name);
        end
    end
    
    u_err = norm(u-u_old, 2) ;
    if u_err / norm(u_old, 2) < cri_th
        break;
    end
    u_old = u ;
end

timecost = cputime - starttime;

h_img = imagesc(Img, [0, 255]);colormap(gray);hold on;axis off,axis equal
[c,h] = contour(u,[0 0],'r','linewidth',2);
totalIterNum=[num2str(n), ' iterations'];
title(['Final contour, ', totalIterNum]);
save_name = [image_name '_final.jpg'];
saveas(h_img, save_name);

figure;
mesh(spf);
title('Final spf function');


    
