function [cc] = concavity(pts)

    try 
        idx = convhull(pts(:,1),pts(:,2)); 
    catch
        cc(1) = 0;
        return;
    end
    m = size(idx, 1);
    conv_bnd = zeros(0, 2);
    for i = 1:(m-1)
        sp = pts(idx(i), :);
        ep = pts(idx(i+1), :);
        K  = [sp; createLine(sp, ep); ep];
        if idx(i) > idx(i+1)
            B  = pts(idx(i+1):idx(i), :);
        else
            B  = pts(idx(i+1):size(pts, 1), :);
        end
  
        D  = sqrt((repmat(K(:,1), 1, size(B,1)) - repmat(B(:,1)', size(K,1), 1)).^2 + (repmat(K(:,2), 1, size(B,1)) - repmat(B(:,2)', size(K,1), 1)).^2);
        cc(i) = max(min(D,[],1)) / max(5, norm(sp-ep));
        %cc(i) = max(min(D,[],2)) / norm(sp-ep);
    end
end