function [line] = createLine(sp, ep)

    if ep(1,1) - sp(1,1) == 0
        n_add = abs(ep(1,2) - sp(1,2))-1;
        if n_add <= 0
            line = [];
            return;
        end
        line(:, 1) = repmat(ep(1,1), n_add, 1);
        if ep(1,2) - sp(1,2) > 0
            line(:, 2) = (sp(1,2)+1):(ep(1,2)-1);
        else
            line(:, 2) = (ep(1,2)+1):(sp(1,2)-1);
        end
        return;
    end
    slope = (ep(1,2) - sp(1,2))/(ep(1,1) - sp(1,1));
    dirx  = sign(ep(1,1) - sp(1,1));
    stepx  = abs(ep(1,1) - sp(1,1))-1;
    diry  = sign(ep(1,2) - sp(1,2));
    stepy  = abs(ep(1,2) - sp(1,2))-1;
    
    if (stepx <= 0) * (stepy <=0) == 1
        line = [];
    elseif stepx < stepy
        line = zeros(stepy, 2);
        line(:, 2) = (sp(1,2)+diry):diry:(ep(1,2)-diry);
        line(:, 1) = round((line(:,2)-sp(1,2))/slope+sp(1,1));
    else
        line = zeros(stepx, 2);
        line(:, 1) = (sp(1,1)+dirx):dirx:(ep(1,1)-dirx);
        line(:, 2) = round((line(:,1)-sp(1,1))*slope+sp(1,2));
    end
end