function [Re_image] = seg_particle_IV(Bi_image, Voted_center, dia_particle)

% Calculate distance map
[n_height, n_width] = size(Bi_image);


% Saperte the particles block by block
area_min = (dia_particle / 2)^2 / 2;
Bi_image2 = imcomplement(Bi_image);
Bi_image2  = bwareaopen(Bi_image2 , round(area_min), 4);
Re_image = imcomplement(Bi_image2);

Region = bwconncomp(Bi_image2, 4);
Stat_Region = regionprops(Region,'BoundingBox','PixelList');
% Find the largest
BoundingBox = cat(1, Stat_Region.BoundingBox);
region_max_height = max(BoundingBox(:, 4));
region_max_width = max(BoundingBox(:, 3));

edge_range = 5;
Temp_height = region_max_height + 2 * edge_range;
Temp_width = region_max_width + 2 * edge_range;
Temp_Region_Bi = zeros(Temp_height, Temp_width);


Temp_Bound = zeros(Temp_height, Temp_width);
Temp_Label = zeros(Temp_height, Temp_width);

Temp_Region_Local_max = zeros(Temp_height, Temp_width);

for i = 1:length(Stat_Region)
    Temp_Region_Bi = 0 .* Temp_Region_Bi;
    x_begin = floor(BoundingBox(i, 1));
    y_begin = floor(BoundingBox(i, 2));
    
    x_range_temp = 1 + edge_range: BoundingBox(i, 3) + edge_range;
    y_range_temp = 1 + edge_range: BoundingBox(i, 4) + edge_range;
    x_range_org = ceil(BoundingBox(i, 1)):floor(BoundingBox(i, 1) + BoundingBox(i, 3));
    y_range_org = ceil(BoundingBox(i, 2)):floor(BoundingBox(i, 2) + BoundingBox(i, 4));
    
    [n_row n_col] = size(Stat_Region(i).PixelList);
    for k = 1:n_row
        Temp_Region_Bi(Stat_Region(i).PixelList(k, 2) - y_begin + edge_range, Stat_Region(i).PixelList(k, 1) - x_begin + edge_range) = 1;
    end
    
    % Copy each region
    
    
    %     imshow(uint8(Temp_Region_Bi * 255))
    %     pause
    
     % Copy each region

    
    Temp_Region_Local_max = 0 .* Temp_Region_Local_max;
    Temp_Region_Local_max(y_range_temp, x_range_temp) = Voted_center(y_range_org, x_range_org);
    Temp_Region_Local_max = Temp_Region_Local_max .* Temp_Region_Bi;
    
%     imshow(uint8(Temp_Region_Bi * 255))
%     pause
    
    num_Local_max = sum(sum(Temp_Region_Local_max));
    
    if num_Local_max == 0
        % Set the region as zero
        Re_image(y_range_org, x_range_org) = imcomplement(imcomplement(Re_image(y_range_org, x_range_org)) .* imcomplement(Temp_Region_Bi(y_range_temp, x_range_temp)));
        continue;
    end
     
    if num_Local_max == 1
        % Re_image(y_range_org, x_range_org) = imcomplement(imcomplement(Re_image(y_range_org, x_range_org)) .* imcomplement(Temp_Region_Bi(y_range_temp, x_range_temp)));
        continue;
    end
   
    [y_Local_max, x_Local_max] = find(Temp_Region_Local_max > 0);
    

    % Sepate the boundary using Voted Center
    num_markers = num_Local_max;
    
    centroids = [x_Local_max y_Local_max];
    
    B_whole = bwboundaries(Temp_Region_Bi,4, 'noholes');
    p_whole = B_whole{1,1};
    
    num_p = size(p_whole, 1);
    angle = zeros(num_p, num_markers);
    dis_cen = zeros(num_p, num_markers);
    label_p = zeros(num_p, 1); 
    label_p_re = zeros(num_p, 2); % The close two markers
    
    nei_range = 3;
    Temp_Bound = 0 .* Temp_Bound;
    x_nei = zeros(2 * nei_range + 1, 1);
    y_nei = zeros(2 * nei_range + 1, 1);
    
    for k = 1:num_p
        
        x_now = p_whole(k, 2);
        y_now = p_whole(k, 1);
        
        % Calculate norm
        for off_set = -nei_range : nei_range
            k_nei = k + off_set;
            if k_nei > num_p
                k_nei = k_nei - num_p;
            end
            if k_nei < 1
                k_nei = k_nei + num_p;
            end
            
            x_nei(off_set + nei_range + 1) = p_whole(k_nei, 2) - x_now;
            y_nei(off_set + nei_range + 1) = p_whole(k_nei, 1) - y_now;
        end
        
        if sum(abs(x_nei)) > 0
            fit_eff = polyfit(x_nei, y_nei, 1);
            x_tan = 1;
            y_tan = fit_eff(1);
        else
            x_tan = 0;
            y_tan = 1;
        end
        
        x_nor = -y_tan;
        y_nor = x_tan;
        
        
        Bi_nei = Temp_Region_Bi(y_now - nei_range:y_now + nei_range, x_now - nei_range:x_now + nei_range);
        nei_size = 2 * nei_range + 1;
        x_M = ones(nei_size,1)*[1:nei_size];
        y_M = (1:nei_size)'*ones(1,nei_size);
        
        area_nei = sum(sum(Bi_nei));
        x_mean = sum(sum(double(Bi_nei) .* x_M))/area_nei;
        y_mean = sum(sum(double(Bi_nei) .* y_M))/area_nei;
        
        x_mean = x_mean - nei_range - 1;
        y_mean = y_mean - nei_range - 1;
        
        %         temp = [x_nor y_nor x_mean y_mean]
        %         imshow(uint8(Bi_nei .* 255))
        %         pause()
        
        if (x_mean * x_nor + y_mean * y_nor) < 0
            x_nor = -x_nor;
            y_nor = -y_nor;
        end
        
        nor = [x_nor y_nor];
        
        for n = 1 : num_markers
            di = [(centroids(n, 1) - x_now) (centroids(n, 2) - y_now)];
            angle(k, n) = (dot(nor,di) / (norm(nor) * norm(di)) + 1.0) / 2.0;
            dis_cen(k, n) = sqrt(di * di');
        end
    end
    
    % Output Boundary Lable
    
    alpha_d_a = 4.0;
    
    for k = 1:num_p
        
        [min_dis, inx_dis] = sort(dis_cen(k, :), 'ascend');
        rate_dis = min_dis(1) / min_dis(2);
        
        if rate_dis < 0.7
            label_p_re(k, 1) = inx_dis(1);
            label_p_re(k, 2) = inx_dis(2);
        else
            cr = dis_cen(k, :) + dia_particle .* alpha_d_a .* (1.0 - angle(k, :));
            if cr(inx_dis(1)) < cr(inx_dis(2))
                label_p_re(k, 1) = inx_dis(1);
                label_p_re(k, 2) = inx_dis(2);
            else
                label_p_re(k, 1) = inx_dis(2);
                label_p_re(k, 2) = inx_dis(1);
            end
        end
    end
    label_p = label_p_re(:, 1);
    
    % Remove some discrete point
    n_med = round(double(num_p) / double(num_markers) / 4.0);
    label_p = round(medfilt1(label_p, n_med));
    for k = 1:num_p
        
        x_now = p_whole(k, 2);
        y_now = p_whole(k, 1);
        
        if label_p(k) == label_p_re(k, 1) || label_p(k) == label_p_re(k, 2)
            Temp_Bound(y_now, x_now) = label_p(k);
        else
            Temp_Bound(y_now, x_now) = label_p_re(k, 1);
        end
    end
    
%         rgb = label2rgb(Temp_Bound,'jet',[.5 .5 .5]);
%         imshow(rgb)
%         pause
%         close all
%         continue;
    
    
    
    % Seperate the region via boundary
    Temp_Label = 0 .* Temp_Label;
    label_in = zeros(Temp_height, Temp_width, num_markers);
    
    Temp_X = repmat(1:Temp_width, Temp_height, 1);
    Temp_Y = repmat((1:Temp_height)', 1, Temp_width);
    for j = 1:num_markers
        if sum(label_p == j) < 5
            continue;
        end
        label_in(:,:,j) = inpolygon(Temp_X, Temp_Y, p_whole(label_p == j, 2), p_whole(label_p == j, 1));
    end
    
    D_in = zeros(Temp_height, Temp_width, num_markers);
    Temp_markers = zeros(Temp_height, Temp_width);
    for n = 1 : num_markers
        Temp_markers = 0 .* Temp_markers;
        Temp_markers(centroids(n, 2), centroids(n, 1)) = 1;
        
        [D, Assign] = bwdist(Temp_markers);
        D_in(:, :, n) = D;
    end
    
    for m = 1:Temp_height
        for n = 1:Temp_width
            
            if Temp_Region_Bi(m, n) == 0
                continue;
            end
            
            min_dis = sort(D_in(m, n, :), 'ascend');
            rate_dis = min_dis(1) / min_dis(2);
            
            if rate_dis < 0.7
                cr_p = exp(-D_in(m, n, :));
            else
                cr_p = exp(-D_in(m, n, :)) .* label_in(m, n, :);
            end
            [cr_max, idx_max] = max(cr_p);
            
            if cr_max > 0
                Temp_Label(m, n) = idx_max;
            end
            
        end
    end
    
    % Out put the boundary to the separated results
     
    Back = Temp_Label > 0;
    [D_Back, Assign_Back] = bwdist(Back);
    
    for m = 1:Temp_height
        for n = 1:Temp_width
            
            if Temp_Region_Bi(m, n) == 0 || D_Back(m, n) == 0
                continue;
            end
            
            idx_label = Assign_Back(m, n);
            
            idx_x = ceil(double(idx_label) / double(Temp_height));
            idx_y = idx_label - Temp_height * (idx_x - 1);
            Temp_Label(m, n) = Temp_Label(idx_y, idx_x);
        end
    end
    
    for j = 1:num_markers
        Temp_Saperated = (Temp_Label == j);
        
        if sum(sum(Temp_Saperated)) == 0
            continue;
        end
        
        Temp_CC = bwconncomp(Temp_Saperated, 4);
        Temp_statall = regionprops(Temp_CC, 'Area');
        Temp_Area = cat(1, Temp_statall.Area);
        [max_Area, max_idx] = max(Temp_Area);
        Temp_Perimeter = bwboundaries(Temp_Saperated, 4);
        
        Temp_Boundary = Temp_Perimeter{max_idx};
        
        for k = 1 : length(Temp_Boundary)
            % Temp_Region_BiTemp_Boundary(k, 1), Temp_Boundary(k, 2) = 0;
            
            % Find the separating boundary
            Neighbor_Label = zeros(1,4);
            Neighbor_Label(1) = Temp_Label(Temp_Boundary(k, 1) - 1, Temp_Boundary(k, 2));
            Neighbor_Label(2) = Temp_Label(Temp_Boundary(k, 1) + 1, Temp_Boundary(k, 2));
            Neighbor_Label(3) = Temp_Label(Temp_Boundary(k, 1), Temp_Boundary(k, 2) - 1);
            Neighbor_Label(4) = Temp_Label(Temp_Boundary(k, 1), Temp_Boundary(k, 2) + 1);
            if sum(Neighbor_Label ~= 0 & Neighbor_Label ~= j) == 0
                continue;
            end
            
            y_org = Temp_Boundary(k, 1) - edge_range + y_begin;
            x_org = Temp_Boundary(k, 2) - edge_range + x_begin;
            
            if y_org < 1 || y_org > n_height || x_org < 1 || x_org > n_width
                continue;
            end
            
            Re_image(y_org, x_org) = 1;
            
        end
        
    end
end

% Remove too small particles
Re_image2 = imcomplement(Re_image);
Re_image2  = bwareaopen(Re_image2 , round(area_min), 4);
Re_image = imcomplement(Re_image2);
